#!/usr/bin/env python

from getopt import getopt, GetoptError
from re import compile as recompile
from sys import argv,exit
from xml.dom.minidom import parseString

from sss.ssslib import comm_lib, LookupError, ProtocolError

if __name__ == '__main__':
    try:
        (opts,args)=getopt(argv[1:],'esdc:m:n:a:')
    except GetoptError, m:
        print m
        print "Usage: eminfo.py [-e] [-s] [-d] [-c component] [-m msg] [-a data] [-n notify]"
        exit(1)

    c='*'
    m='*'
    d='*'
    n='*'

    for opt in opts:
        if opt[0] == '-c':
            c=opt[1]
        elif opt[0] == '-m':
            m=opt[1]
        elif opt[0] == '-n':
            n=opt[1]
        elif opt[0] == '-a':
            d=opt[1]

    if '-s' in argv:
        msg="<get-subscription><subscription component='%s' msg='%s' data='%s' notify='%s' matches='*' delivered='*' failures='*' last='*'/></get-subscription>"%(c,d,m,n)
    elif '-e' in argv:
        msg="<get-event><event component='%s' msg='%s' data='%s' time='*'/></get-event>"%(c,m,d)
    else:
        print "Usage: eminfo.py [-e] [-s] [-d] [-c component]"
        print "one of -e or -s are required"
        exit(1)

    debug=len([x for x in argv if x=='-d'])
    c=comm_lib(debug=debug)
    try:
        h=c.ClientInit("event-manager")
    except LookupError:
        print "Event Manager not registered"
        exit(1)
    except ProtocolError:
        print "Protocol error"
        exit(1)
    c.SendMessage(h,msg)
    r=c.RecvMessage(h)
    c.ClientClose(h)
    response=parseString(r)
    if response.documentElement.tagName == 'Error':
        print "Server failure"
    else:
        for item in response.childNodes[0].childNodes:
            print item.toxml()
