#!/usr/bin/env python

import getopt
import sys
import sss.ssslib

values = {}
values['-c']      = '*'
values['-h']      = '*'
values['-p']      = '*'
values['-r']      = '*'
values['-s']      = '*'
values['-t']      = '*'

if len(sys.argv) == 1:
    print "Usage: sdremove.py [-d] [-n] [-c component] [-h host] [-p port] [-r protocol] [-s schema_version] [-t tier]"
    sys.exit(1)

try:
    (opts,args) = getopt.getopt(sys.argv[1:],'dnc:h:p:r:s:t:')
except getopt.GetoptError, msg:
    print "Usage: sdremove.py [-d] [-n] [-c component] [-h host] [-p port] [-r protocol] [-s schema_version] [-t tier]"
    print msg

for (opt,arg) in opts:
    values[opt] = arg

xml = "<del-location><location component='%s' host='%s' port='%s' protocol='%s' schema_version='%s' tier='%s'/></del-location>"%(values['-c'],values['-h'],values['-p'],values['-r'],values['-s'],values['-t'])

if not ('-n' in sys.argv):
    comm = sss.ssslib.comm_lib(debug=('-d' in sys.argv))
    handle = comm.ClientInit("service-directory")
    comm.SendMessage(handle,xml)
    resp = comm.RecvMessage(handle)
    comm.ClientClose(handle)
    print resp
else:
    print xml
