#include <stdio.h>
#include <ssslib.h>

int main(int argc, char *argv[]){

  char *buf;
  char *handle;
  int i;
  SSS sss;
  SSS_ConfigDict conf;
  char errbuf[MAXERRLENGTH+1];
  int type;
  int rc;

  if (argc < 2){
    fprintf(stderr,"Usage: client_test <conffile>\n");
    exit(1);
  }
  
  for(i=0;i<1;i++){

  sss = SSS_Init(argv[1],1);

  printf("SSS returned by SSS_Init is %p\n",(void *)sss);

  if(!sss)
    return 1;

  conf = SSS_GetGlobalConfigDict(sss);

  printf("debug is :%s:\n",SSS_GetFromConfigDict(conf,"debug"));
  printf("sd_host is :%s:\n",SSS_GetFromConfigDict(conf,"sd_host"));
  printf("sd_port is :%s:\n",SSS_GetFromConfigDict(conf,"sd_port"));
  printf("sd_protocol is :%s:\n",SSS_GetFromConfigDict(conf,"sd_protocol"));

  SSS_FreeConfigDict(conf);

  handle = SSS_ClientInit(sss,"test_service");

  if (!handle){
    SSS_strerror(sss->sss_errno,errbuf,&type);
    printf("error: %s\n",errbuf);
    SSS_Close(sss);
    return 1;
  }
  
  rc = SSS_SendMessage(sss,handle,"Test client send 1");

  if (rc == -1){
    SSS_strerror(sss->sss_errno,errbuf,&type);
    printf("error: %s\n",errbuf);
    SSS_Close(sss);
    return 1;
  }
  
  buf = SSS_RecvMessage(sss,handle);

  if (!buf){
    SSS_strerror(sss->sss_errno,errbuf,&type);
    printf("error: %s\n",errbuf);
    SSS_Close(sss);
    return 1;
  }
  
  printf("Got :%s: back from server\n",buf);

  free(buf);

  rc = SSS_SendMessage(sss,handle,"Test client send 2");

  if (rc == -1){
    SSS_strerror(sss->sss_errno,errbuf,&type);
    printf("error: %s\n",errbuf);
    SSS_Close(sss);
    return 1;
  }
  
  buf = SSS_RecvMessage(sss,handle);

  if (!buf){
    SSS_strerror(sss->sss_errno,errbuf,&type);
    printf("error: %s\n",errbuf);
    SSS_Close(sss);
    return 1;
  }

  printf("Got :%s: back from server\n",buf);

  free(buf);

  rc = SSS_SendMessage(sss,handle,"Test client send 3");

  if (rc == -1){
    SSS_strerror(sss->sss_errno,errbuf,&type);
    printf("error: %s\n",errbuf);
    SSS_Close(sss);
    return 1;
  }
  
  buf = SSS_RecvMessage(sss,handle);

  if (!buf){
    SSS_strerror(sss->sss_errno,errbuf,&type);
    printf("error: %s\n",errbuf);
    SSS_Close(sss);
    return 1;
  }

  printf("Got :%s: back from server\n",buf);

  free(buf);

  rc = SSS_SendMessage(sss,handle,"Test client send 4");

  if (rc == -1){
    SSS_strerror(sss->sss_errno,errbuf,&type);
    printf("error: %s\n",errbuf);
    SSS_Close(sss);
    return 1;
  }
  
  buf = SSS_RecvMessage(sss,handle);

  if (!buf){
    SSS_strerror(sss->sss_errno,errbuf,&type);
    printf("error: %s\n",errbuf);
    SSS_Close(sss);
    return 1;
  }

  printf("Got :%s: back from server\n",buf);

  free(buf);

  rc = SSS_ClientClose(sss,handle);
    
  if (rc == -1){
    SSS_strerror(sss->sss_errno,errbuf,&type);
    printf("error: %s\n",errbuf);
    SSS_Close(sss);
    return 1;
  }
  
  SSS_Close(sss);

  }

  return 0;
}

