Name: ssslib
Version: 0.98.5pre6
Release: 1
Summary: SSS Library
License: GPL
Group: Libraries
Source: sss-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: openssl-devel, expat-devel, xerces-c-devel, autoconf
Requires: openssl, expat

# Read: if python2 flag not defined, define mutually exclusive flag
%{!?_with_python2: %define _without_python2 --without-python2}
# Read: error if both flags used
%{?_with_python2: %{?_without_python2: %{error: both _with_python2 and _without_python2}}}

# Define more legible variable to avoid crazy macro syntax
# Read: true if _with_python2 defined, else false
%if %{?_with_python2:1}%{!?_with_python2:0}
%define aspython2 1
%else
%define aspython2 0
%endif

%if %{aspython2}
Requires: python2 >= 2.0
BuildRequires: python2-devel
%define python /usr/bin/python2
%else
Requires: python >= 2.0
BuildRequires: python-devel >= 2.0
%define python python
%endif

%description
This is a package of SSSLib, from the SCIDAC Scalable Systems Software 
Project.

%package -n ssslib-python
Version: %{version}
Summary: Python bindings for ssslib
Group: Libraries
Requires: ssslib = %{version}

%description -n ssslib-python
This is a set of python bindings for ssslib

%package -n sss-wrapper
Version: %{version}
Summary: setgid wrapper for sss clients
Group: Applications/System

%description -n sss-wrapper
This wrapper controls access to sss clients.

%package -n ssslib-perl
Version: %{version}
Summary: Perl bindings for ssslib
Group: Libraries
Requires: ssslib = %{version}

%package -n sss-bcm-servers
Version: %{version}
Summary: SSS BCM components
Group: Applications/System
Requires: ssslib, ssslib-python, MySQL-python

%description -n sss-bcm-servers
This is an implementation of the sss bcm stack

%package -n sss-pm-servers
Version: %{version}
Summary: SSS Process Management components
Group: Applications/System
Requires: ssslib, ssslib-python

%description -n sss-pm-servers 
These are the ANL/SSS Process management daemons - Queue Manager,
Scheduler, and Process manager.

%package -n sss-pm-clients
Version: %{version}
Summary: SSS Process Management clients
Group: Applications/System
Requires: ssslib, ssslib-python

%description -n sss-pm-clients
Clients need for user-level job submission and query.

%package -n sss-bcm-clients
Version: %{version}
Summary: SSS BCM clients
Group: Applications/System
Requires: ssslib, ssslib-python

%description -n sss-bcm-clients
This is an implementation of the sss bcm clients

%package -n sss-infrastructure
Version: %{version}
Summary: Service directory and Event Manager implementations
Group: Applications/System
Requires: ssslib, ssslib-python

%description -n sss-infrastructure
The Service Directory and Event Manager. 

%package -n sss-infrastructure-clients
Version: %{version}
Summary: Service directory and Event Manager query clients
Group: Applications/System
Requires: ssslib, ssslib-python

%description -n sss-infrastructure-clients
sdstat, eminfo, sdremove

%package -n sss-validate
Version: %{version}
Summary: Validation library for SSSLib
Group: Libraries
Requires: xerces-c = 2.3.0-3

%description -n sss-validate
The XML SChema validation library used in SSSLib components.

%package -n sss-validate-python
Version: %{version}
Summary: Validation library for SSSLib - python bindings
Group: Libraries
Requires: sss-validate = %{version}

%description -n sss-validate-python
The Python bindings to sss-validate.

%package -n sss-clients
Version: %{version}
Summary: Client programs for sss
Group: Applications/System
Requires: ssslib = %{version},ssslib-python = %{version}

%description -n sss-clients
A set of clients to sss daemons.

%package -n sss-apitest
Version: %{version}
Summary: APITest
Group: Applications/System
Requires: ssslib-python

%description -n sss-apitest
APITest tests interfaces of runtime environments

%description -n ssslib-perl
This is a set of perl bindings for ssslib

%prep
%setup -q -n sss-%{version}

# Change #! line in *.py files 
# Note: in prep so we can run setup.py cleanly & gen .pyc files cleanly
%if %{aspython2}
    DIR=$RPM_BUILD_DIR/sss-%{version}
    echo "Changing #!... line to Python2"
    for file in `find $DIR | grep -e ".py$"` ; do
    	f2=$file.tmp
    	f3=$file.bak
    
    	# Get mode of $file
    	mode=`stat $file |grep -e "^Access:" | head -1 \
    	| awk '{print $2}' | sed "s|(||" | awk -F/ '{print $1}'`
    
    	echo "  file: $file"
    	cat $file | sed "1s%#!.*%#!/usr/bin/env python2%" > $f2
    	mv -f $file $f3   &&  mv -f $f2 $file   &&   rm -f $f2 $f3
    	chmod $mode $file
    done
%endif


%build
./configure --prefix=/usr --mandir=/usr/share/man
make 

%install 
make install DESTDIR=%{buildroot}
for file in lib/python/INSTALLED_FILES validate_lib/INSTALLED_FILES apitest/INSTALLED_FILES; do
  cat $file | sed -e 's,%{buildroot},,g' > $file.new
done
mkdir -p %{buildroot}/var/spool/sss

%files 
%defattr(-,root,root)
/usr/lib/libsss*
/usr/include/ssslib.h
/usr/lib/sss/*
/usr/share/sss/sss-error.xsd

%config(noreplace) /etc/sss.conf
%config(noreplace) /etc/ssslib.conf

%files -n sss-wrapper
/usr/bin/wrapper

%files -n ssslib-python
%defattr(-,root,root)
/usr/lib/python2.2/site-packages/sss/*
/var/spool/sss

%files -n sss-bcm-clients
%defattr(755,root,root)
/usr/sbin/bs-client.py
/usr/sbin/chi-client.py
/usr/sbin/nsmclient.py
/etc/init.d/nsmboot
/etc/init.d/nsmup
/etc/init.d/nsmreboot

%files -n ssslib-perl
%defattr(-,root,root)
/usr/lib/perl5/*/site_perl/*

%files -n sss-infrastructure
/usr/sbin/sd.py
/usr/sbin/emng.py
/etc/init.d/sss
/usr/share/sss/sd-types.xsd
/usr/share/sss/em-types.xsd
/usr/share/sss/service-directory-in.xsd
/usr/share/sss/service-directory-out.xsd
/usr/share/sss/event-manager-in.xsd
/usr/share/sss/event-manager-out.xsd

%files -n sss-infrastructure-clients
/usr/sbin/sdstat.py
/usr/sbin/sdremove.py
/usr/sbin/eminfo.py
/usr/sbin/embench.py
/usr/sbin/event_tail.py
/usr/sbin/sdbench.py
/usr/share/man/man1/eminfo.1.gz
/usr/share/man/man1/sdstat.1.gz
/usr/share/man/man8/sd.8.gz
/usr/share/man/man8/emng.8.gz

%files -n sss-pm-servers
/etc/init.d/sss-pm
/usr/sbin/mpdpm.py
/usr/share/sss/process-manager-in.xsd
/usr/share/sss/process-manager-out.xsd
/usr/share/sss/pm-types.xsd
/usr/share/man/man8/mpdpm.8.gz

%files -n sss-pm-clients
/usr/bin/dsh.py
/usr/share/man/man1/pminfo.1.gz

%files -n sss-validate-python
/usr/lib/python2.2/site-packages/validate*
%defattr(-,root,root)

%files -n sss-bcm-servers
/usr/sbin/nsm.py
/usr/sbin/bs.py
/usr/sbin/chi.py
/etc/init.d/sss-bcm
/usr/share/man/man8/nsm.8.gz
/usr/share/sss/chi-types.xsd
/usr/share/sss/bs-types.xsd
/usr/share/sss/node-state-manager-types.xsd
/usr/share/sss/node-state-manager-in.xsd
/usr/share/sss/node-state-manager-out.xsd
/usr/share/sss/cluster-hardware-in.xsd
/usr/share/sss/cluster-hardware-out.xsd
/usr/share/sss/build-system-in.xsd
/usr/share/sss/build-system-out.xsd

%files -n sss-validate
/usr/lib/libvalidate*

%files -n sss-apitest -f apitest/INSTALLED_FILES.new
/usr/bin/apitest.py
/usr/lib/python2.2/site-packages/testbase.py*
/usr/lib/python2.2/site-packages/testlibs.py*
/usr/lib/python2.2/site-packages/graph.py*
/usr/lib/python2.2/site-packages/framework.py*
/usr/lib/python2.2/site-packages/errorhandlers.py*

%post -n sss-infrastructure
chkconfig --add sss

%post -n sss-bcm-clients
chkconfig --add nsmreboot
chkconfig --add nsmboot
chkconfig --add nsmup

%changelog
* Wed Oct 15 2003 Narayan Desai <desai@mcs.anl.gov> - 0.98.1-1
- Update to new upstream version
- Update to use the automake/libtool/ltdl files

* Tue May 20 2003 Narayan Desai <desai@mcs.anl.gov> - 0.97pre1-1
- kill mayor slave stuff
- add apitest 
- bump version

* Wed Apr  9 2003 Narayan Desai <desai@mcs.anl.gov> - 0.96.1-1
- bump to new release
- update mayor_slave rpm

* Thu Mar 20 2003 Narayan Desai <desai@mcs.anl.gov> - 0.96pre3-1
- bump version

* Tue Mar 18 2003 Narayan Desai <desai@mcs.anl.gov> - 0.96pre2-1
- bump version number
- reslice package boundaries

* Tue Mar 18 2003 Narayan Desai <desai@mcs.anl.gov> - 0.96pre1-1
- kill sss-schemas target

* Wed Feb 19 2003 Narayan Desai <desai@mcs.anl.gov> - 0.95-1
- Remove sss-old

* Thu Feb 13 2003 Narayan Desai <desai@mcs.anl.gov> - 0.94-1
- moved a bunch of spec file stuff to Makefiles
- integrate schema stuff
- integrate validate_lib stuff

* Fri Feb  7 2003 Thomas Naughton <naughtont@ornl.gov> - 0.93-1
- Added --with-python2 logic for conditional builds, see comments for refs
- Added conditional logic to help w/ python2 builds
- Change %{PYTHON} to %{python} b/c all cap already defined.
- Added more requires for deps discovered while building/installing
- Broke Requires/BuildRequires line apart for Python.

* Thu Jan 30 2003 Thomas Naughton <naughtont@ornl.gov> - 0.91-1
- Changes (hacks) to try and be more generic, build on RH systems.

* Tue Oct 15 2002 Narayan Desai <desai@mcs.anl.gov> - 0.90-1
- Change to new Makefile structure

* Tue Jul 02 2002 Narayan Desai <desai@mcs.anl.gov> - 0.03-1
- initial release
